declare class CorrelationTracker {
    constructor(a?: number, b?: number, c?: number, d?: number, e?: number, f?: number, g?: number, h?: number);
    startTrack(img: Array2D, bbox: _Rectangle): void;
    predict(img: Array2D): _Rectangle;
    update(img: Array2D, guess: _Rectangle): _Rectangle;
    getPosition(): _Rectangle;
}
declare class _Rectangle {
    constructor(l: number, t: number, r: number, b: number);
    left: Readonly<number>;
    right: Readonly<number>;
    top: Readonly<number>;
    bottom: Readonly<number>;
    width: Readonly<number>;
    height: Readonly<number>;
}
declare class Array2D {
    constructor();
    constructor(h: number, w: number);
    setSize(h: number, w: number): void;
    set(y: number, x: number, value: number[]): void;
    width: Readonly<number>;
    height: Readonly<number>;
}
declare interface dlib {
    CorrelationTracker: typeof CorrelationTracker;
    Array2D: typeof Array2D;
    Rectangle: typeof _Rectangle;
    readImageData(pointer: number, width: number, height: number): Array2D;
    HEAP8: Int8Array;
    _malloc(size: number): number;
    _free(pointer: number): void;
}
declare const lib: dlib;
interface Rectangle {
    x: number;
    y: number;
    width: number;
    height: number;
}
export declare class VideoCorrelationTracker {
    video: HTMLVideoElement;
    rect: Rectangle;
    tracker: CorrelationTracker;
    private static ptr;
    static freeMemory(): void;
    static reserveMemory(video: HTMLVideoElement): void;
    private readonly videoArray2D;
    readonly prediction: Rectangle;
    constructor(video: HTMLVideoElement, rect: Rectangle);
    update(rect: Rectangle): void;
}
export { lib };
